// package jtalk;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

public class JSplash extends JWindow implements KeyListener, MouseListener
{
	
	/**
	 *  JSplash constructs a splash screen (JWindow).
	 *		parent is the parent frame for the window
	 *		filename is the JPEG/GIF file to show as the splash
	 *		timeout is time in milliseconds to display the splash
	 */
	public JSplash(JFrame parent, String filename, String version) 
	{ 
		super(parent); 
	
	/** start of fancy background */
        ((JPanel)getContentPane()).setOpaque(false);
       
        final ImageIcon m_image= new ImageIcon("images/background.jpg");
        final int winc = m_image.getIconWidth();
        final int hinc = m_image.getIconHeight();
        JLabel backlabel = new JLabel("");
        
        if (m_image.getIconWidth() > 0 && m_image.getIconHeight() > 0)
        {
            backlabel = new JLabel() {
                
                public void paintComponent(Graphics g) {
                    int w = getParent().getSize().width;
                    int h = getParent().getSize().height;
                    for (int i=0;i<h+hinc;i=i+hinc)
                    {
                        for (int j=0;j<w+winc;j=j+winc)
                        {
                            m_image.paintIcon(this,g,j,i);
                        }
                    }
                }
                public Dimension getPreferredSize() {
                    return new Dimension(super.getSize());
                }
                public Dimension getMinimumSize() {
                    return getPreferredSize();
                }
            };
        }
        
        getLayeredPane().add(backlabel, new Integer(Integer.MIN_VALUE));
        backlabel.setBounds(0,0,5000,5000);
	/** end of fancy background */	    
	
		ImageIcon image = new ImageIcon(filename); 
		if (image!=null)
		{
		    int w = image.getIconWidth() + 4; 
		    int h = image.getIconHeight() + 4; 
		    Dimension screen = Toolkit.getDefaultToolkit().getScreenSize(); 
		    int x = (screen.width - w) / 2; 
		    int y = (screen.height - h) / 2; 
		    setBounds(x, y, w, h); 
		
		    getContentPane().setLayout(null); 
		    JLabel picture = new JLabel(image); 
		    getContentPane().add(picture); 
   		    picture.setBounds(2, 2 ,image.getIconWidth()+2, image.getIconHeight()+2);
            picture.setBorder(new BevelBorder(BevelBorder.RAISED)); 
        
            /** bulid version */
            JLabel versionLabel = new JLabel(version); 
            versionLabel.setForeground(Color.blue);
            getContentPane().add(versionLabel); 
		    versionLabel.setBounds(image.getIconWidth()-70, 15, 70, 25);
		}
		addKeyListener(this); 
		addMouseListener(this); 
		parent.addMouseListener(this); 
		
		
	
	
	
	} 
	
	
	// Dismiss the window on a key press, ignore rest.
	public void keyTyped(KeyEvent event) 
	    {} 
	public void keyReleased(KeyEvent event) 
	    {} 
	public void keyPressed(KeyEvent event) 
	{ 
		hideSplash();
	} 
	
	// Dismiss the window on a mouse click, ignore rest.
	public void mousePressed(MouseEvent event) 
	    {} 
	public void mouseReleased(MouseEvent event) 
	    {} 
	public void mouseEntered(MouseEvent event) 
	    {} 
	public void mouseExited(MouseEvent event) 
	    {} 
	public void mouseClicked(MouseEvent event) 
	{ 
        hideSplash();
	}
	public void hideSplash()
	{
        setVisible(false); 
		dispose(); 
	}

} 
