// package jtalk;

import java.awt.*;
import javax.swing.*;

public class addressBookTableModel extends jtableModel
{
	public addressBookTableModel(String columnNames[], Object data[][])
	{
		super(columnNames, data);
	}
	
    public void setValueAt(Object value, int row, int col)
    {
        // This method is derived from class jtableModel
        // to do: code goes here
        	if (col!=getColumnCount()-1 && (value.toString().length()<1))
			{
                Toolkit.getDefaultToolkit().beep();
    	        JOptionPane.showMessageDialog(null,
    	            "If you want to delete an entry just click on delete.",
	                "JTalk Address Book Error", 
    	        JOptionPane.INFORMATION_MESSAGE);
	    	    return;
				
			}
			
			if(col==0)
			{
				for (int i=0; i<getRowCount(); i++)
				{
					if (i==row)
						continue;
					if (getValueAt(i, col).toString().equalsIgnoreCase(value.toString()))
					{
	                    Toolkit.getDefaultToolkit().beep();
    	                JOptionPane.showMessageDialog(null,
    	                "Duplicate nick name.",
	                    "JTalk Address Book Error", 
    	                JOptionPane.ERROR_MESSAGE);
	    	            return;
					}
				}
			}
			
			else if(col==1 || col==2)
			{
				int otherCol=(col==1)?2:1;
				for (int i=0; i<getRowCount(); i++)
				{
					if (i==row)
						continue;
					if (getValueAt(i, col).toString().equalsIgnoreCase(value.toString())&&
						getValueAt(i, otherCol).toString().equalsIgnoreCase(getValueAt(row, otherCol).toString()))
					{
					    Toolkit.getDefaultToolkit().beep();
    	                JOptionPane.showMessageDialog(null,
    	                "Duplicate entry.",
	                    "JTalk Address Book Error", 
    	                JOptionPane.ERROR_MESSAGE);
						return;
					}
				}
			    String temp=value.toString();
				int indexOfStar=temp.indexOf("*");
				if ((indexOfStar==0 && indexOfStar == temp.lastIndexOf("*"))
				    || indexOfStar== temp.length()-1) 
				{
				    data[row][0]="";
				}
				else if (indexOfStar!=-1) 
				{
				    String[] message;
				    if (col==1)
				    {
				        String[] msg={
       	                    "Invalid mask for user name.",
       	                    "Valid masks are:",
                            "   * (all users)",
                            "   *foo (only users whos name ends with foo)",
                            "   foo* (only users whos name starts with foo)",
				        };
				        message=msg;
				    }
				    else
				    {
                        String[] msg={
       	                    "Invalid mask for IP/DNS.",
       	                    "Valid masks are:",
                            "   * (all IP/DNS)",
                            "   *.com (only .com DNS's)",
                            "   123.45* (only sites whos ip starts with 123.45)",
				        };
                        message=msg;
				    }
                    Toolkit.getDefaultToolkit().beep();
    	            JOptionPane.showMessageDialog(null,
                        message,
                        "JTalk Address Book Error", 
    	                JOptionPane.ERROR_MESSAGE);
                     return;
                    }
			}
			
			else if (col==4 && value.toString().equals("true"))
			{
			    boolean validEntry=true;
			    for(int j=0; j<3; j++)
				{
					String str=getValueAt(row, j).toString();
					if (str.length()<1 || str.equals(""))
					{
					    if (j==0)
					    {
					        if (!this.isCellEditable(row, 0))
					            continue;
					    }
					    validEntry=false;
					    break;
					}
				}
				if (!validEntry)
				{
				    Toolkit.getDefaultToolkit().beep();
    	            JOptionPane.showMessageDialog(null,
    	               "Can't activate an entry when some of the fields are blank.",
	                   "JTalk Address Book Error", 
    	               JOptionPane.ERROR_MESSAGE);
				    return;
				}
			}
/*	        else if (data[0][col] instanceof Integer) 
			{
                //If we don't do something like this, the column
                //switches to contain Strings.
                try 
				{
                    data[row][col] = new Integer((String)value);
                    fireTableCellUpdated(row, col);
                }
				catch (NumberFormatException e) 
				{
                    JOptionPane.showMessageDialog(this,
                        "The \"" + getColumnName(col)
                        + "\" column accepts only integer values.");
					return;
                }
            }
  */
			
			data[row][col] = value;
            fireTableCellUpdated(row, col);
    }

    public boolean isCellEditable(int row, int col)
    {
        // This method is derived from class jtableModel
        // to do: code goes here
        if(col==0)
        {
            if (data[row][1].toString().indexOf("*")>-1 || data[row][2].toString().indexOf("*")>-1)
                return false;
        }
     	return true;
	}

}