// package jtalk;

import java.awt.Toolkit;
import javax.swing.JOptionPane;
import java.net.*;
import java.io.*;
import java.util.*;
import java.text.DateFormat;
import java.text.ParseException;

public class answerMachine
{
	boolean DEBUG;
	boolean FORWARD_TO_EMAIL=false;
	String SMTP_SERVER="";
	String FORWARD_EMAIL_ADDRESS="";
	private static final int NUMBER_OF_FIELDS_IN_THE_MESSAGE_HEADERS=4;
	
	public answerMachine(boolean debug)
	{
	    DEBUG=debug;
    	setInv();
	}
	
	public void saveMessage(String fromWhom, String message)
	{

		if (FORWARD_TO_EMAIL)
		{
			email sm=new email(SMTP_SERVER, DEBUG);
			sm.send(fromWhom, FORWARD_EMAIL_ADDRESS, constants.ANSWER_MACHINE_SUBJECT+fromWhom, message);
			return;
		}
		File theFile=getNextMesageFileName();
		PrintWriter thePrintWriter=null;
		try
		{
		    thePrintWriter=new PrintWriter(new FileOutputStream(theFile));
		}
		catch (IOException e)
		{
			return;
		}
		thePrintWriter.println(constants.ANSWER_MACHINE_WARNING);
		thePrintWriter.print(constants.ANSWER_MACHINE_FROM);
		thePrintWriter.println(fromWhom); 
		thePrintWriter.print(constants.ANSWER_MACHINE_DATE);
		thePrintWriter.println(DateFormat.getDateTimeInstance().format(new Date()));
		thePrintWriter.print(constants.ANSWER_MACHINE_STATUS);
		thePrintWriter.println("NEW MESSAGE");
		thePrintWriter.println();
		thePrintWriter.print(message);
		thePrintWriter.flush();
		thePrintWriter.close();
	}
	
	public static String getMessageContents(String fileName)
	{
	    String messageContents="";
	    RandomAccessFile theRandomAccessFile;
		try
		{
			theRandomAccessFile=new RandomAccessFile(fileName, "rw");
		}
		catch (FileNotFoundException e)
		{
			return null;
		}
		catch (IOException e)
		{
			return null;
		}
		try
		{
			theRandomAccessFile.readLine();
	 	    theRandomAccessFile.readLine();
			theRandomAccessFile.readLine();
			//the filepointer in now in the right location let's rewirite that line
			theRandomAccessFile.writeBytes(constants.ANSWER_MACHINE_STATUS);
			theRandomAccessFile.writeBytes("OLD MESSAGE");
		    theRandomAccessFile.readLine();
		    theRandomAccessFile.readLine();
			while(theRandomAccessFile.getFilePointer()<theRandomAccessFile.length())
			    messageContents+=theRandomAccessFile.readLine()+"\r\n";
		    	theRandomAccessFile.close();
		}
		catch (IOException e)
		{
		}
		try
		{
		    theRandomAccessFile.close();
		}
		catch (IOException e)
		{
		}
		
		return messageContents;
	}
	
	public static void setMessageAsNew(String fileName)
	{
	    RandomAccessFile theRandomAccessFile;
		try
		{
			theRandomAccessFile=new RandomAccessFile(fileName, "rw");
		}
		catch (FileNotFoundException e)
		{
			return;
		}
		catch (IOException e)
		{
			return;
		}
		try
		{
            theRandomAccessFile.readLine();
	 	    theRandomAccessFile.readLine();
			theRandomAccessFile.readLine();
			//the filepointer in now in the right location let's rewirite that line
			theRandomAccessFile.writeBytes(constants.ANSWER_MACHINE_STATUS);
			theRandomAccessFile.writeBytes("NEW MESSAGE");
		}
		catch (IOException e)
		{
		}
        try
		{
		    theRandomAccessFile.close();
		}
		catch (IOException e)
		{
		}
				
	}
	
	public static Object[][] getMessageHeaders(boolean DEBUG)
	{
		Vector theVector=new Vector();
		Object[][] data;
		File checkFile;		
		RandomAccessFile  theRandomAccessFile;
		String fromWhom="";
		String theDate="";
		String theStatus="";
		
		filter theFilter = new filter ("."+constants.ANSWER_MACHINE_FILENAME_SUFFIX); 
        String[] messages = (new File (".")).list(theFilter); 
        
		for(int count=0; count<messages.length; count++)
		{
			checkFile=new File(messages[count]);
			try
			{
				theRandomAccessFile=new RandomAccessFile(checkFile, "r");
			}
			catch (FileNotFoundException e)
			{
				continue;
			}
			catch (IOException e)
			{
				continue;
			}
			try
			{
				theRandomAccessFile.readLine();
	 		    fromWhom=theRandomAccessFile.readLine();
				theDate=theRandomAccessFile.readLine();
				theStatus=theRandomAccessFile.readLine();
				theRandomAccessFile.readLine();
				theRandomAccessFile.close();
			}
			catch (IOException e)
			{
			}
			finally
			{
				try
				{
					theRandomAccessFile.close();
				}
				catch (IOException e)
				{
				}
			}

			if ((fromWhom==null) || (fromWhom.length()+1<constants.ANSWER_MACHINE_FROM.length())
			        || (theDate==null) || (theDate.length()+1<constants.ANSWER_MACHINE_DATE.length())
		            || (theStatus==null) || (theStatus.length()+1<constants.ANSWER_MACHINE_STATUS.length()))
		    {
		        try 
		        {
	                // Beep
    	            Toolkit.getDefaultToolkit().beep();
    	            // Show a confirmation dialog
    	            String[] error={
    	                "This message is corupted: "+checkFile.getName()+"","Do you want to delete it?"};
    	            int reply = JOptionPane.showConfirmDialog(null, 
                                                      error,
	    	                                          "JTalk Answer Machine - Error" , 
	    	                                          JOptionPane.YES_NO_OPTION, 
	    	                                          JOptionPane.QUESTION_MESSAGE);
		    // If the confirmation was affirmative, handle exiting.
		    if (reply == JOptionPane.YES_OPTION)
		    {
       			checkFile.delete();
		    }
		} 
		catch (Exception e) 
		{
		}
		        continue;
		    }

			fromWhom=fromWhom.substring(constants.ANSWER_MACHINE_FROM.length(), fromWhom.length());
			theDate=theDate.substring(constants.ANSWER_MACHINE_DATE.length(), theDate.length());
			theStatus=theStatus.substring(constants.ANSWER_MACHINE_STATUS.length(), theStatus.length());
		
			theVector.addElement(fromWhom.trim());
			try
			{
			    theVector.addElement(DateFormat.getDateTimeInstance().parse(theDate));
			}
			catch(ParseException e)
			{
			    if (DEBUG)
			        System.err.println("ERROR: Couldn't parse a date stamp of the message: "+checkFile+" "+e);
			    theVector.addElement(DateFormat.getDateTimeInstance().format(new Date()));
			}
			if (theStatus.indexOf("NEW")>=0)
			    theVector.addElement(Boolean.TRUE);
            else
                theVector.addElement(Boolean.FALSE);
			theVector.addElement(checkFile.getName());
		}
		
		if (theVector.size()%NUMBER_OF_FIELDS_IN_THE_MESSAGE_HEADERS!=0)
		{
		    if (DEBUG)
			    System.err.println("Error in retriving Answer Message Headers");
			return null;
		}
		data=new Object[theVector.size()/NUMBER_OF_FIELDS_IN_THE_MESSAGE_HEADERS][NUMBER_OF_FIELDS_IN_THE_MESSAGE_HEADERS];
		int x=0;
		for (int i=0; i<theVector.size()/NUMBER_OF_FIELDS_IN_THE_MESSAGE_HEADERS; i++)
		{
		    for (int j=0; j<NUMBER_OF_FIELDS_IN_THE_MESSAGE_HEADERS; j++)
		    {
    		    data[i][j]=theVector.elementAt(x++);
		    }
		}
		return data;
	}

	private File getNextMesageFileName()
	{
		int count=0;
		File checkFile;		
		do
		{
			checkFile=new File(new String(constants.ANSWER_MACHINE_FILENAME_PREFIX+(count++)+"."+constants.ANSWER_MACHINE_FILENAME_SUFFIX));
		}while (checkFile.exists());
		return checkFile;
	}
	
public void setInv()
	{
		configurations theConfigurations=new configurations(DEBUG);
		theConfigurations.openConfigurationFile();
	
	    if(theConfigurations.isValidConfigurationsFile())
		{
			FORWARD_TO_EMAIL=((Boolean)theConfigurations.getData("Answer_Forward_To_Email")).booleanValue();
			SMTP_SERVER=(String)theConfigurations.getData("Advanced_SMTP_Server");
			FORWARD_EMAIL_ADDRESS=(String)theConfigurations.getData("Answer_Forward_Email");
			if(FORWARD_TO_EMAIL)
			{
				if(SMTP_SERVER.length()<2 || FORWARD_EMAIL_ADDRESS.length()<3)
					FORWARD_TO_EMAIL=false;
			}
		}
		theConfigurations.closeConfigurationFile();
	}
}
