// package jtalk;

import java.net.*;
import java.io.*;
import java.util.*;
import java.text.DateFormat;

public class comunicate 
{

    boolean DEBUG;
	DatagramPacket inDatagramPacket;	
	DatagramPacket outDatagramPacket;	
	byte[] buffer=new byte[constants.CTL_RESPONSE_LENGTH];
	DatagramSocket theDatagramSocket;
	int RESEND_WAIT;
	public static int count=0;
	
	public comunicate(DatagramSocket theDatagramSocket, boolean DEBUG)
	{
		this.theDatagramSocket=theDatagramSocket;
		this.DEBUG=DEBUG;
		configurations theConfigurations=new configurations(DEBUG);
		theConfigurations.openConfigurationFile();
		if(theConfigurations.isValidConfigurationsFile())
		{
			RESEND_WAIT=((Integer)theConfigurations.getData("Advanced_Max_Wait")).intValue();
		}
		else
		{
			RESEND_WAIT=constants.RESEND_WAIT;
		}
		theConfigurations.closeConfigurationFile();
	}	
	
	ctl_response sendWithConfirmation(ctl_msg request, String destIP)
	{
		ctl_response response=null;
		for(int tries= 0; tries<constants.MAX_TRIES; tries++)
		{
			sendRequest(request, destIP);
			response=recieveResponse(destIP);	
			if (response!=null)
				break;
		}
		return response;		
	}
	
	boolean sendRequest(ctl_msg request, String destIP)
	{
		InetAddress destIPAddress;
		try
		{
			destIPAddress=InetAddress.getByName(destIP);
		}
		catch (UnknownHostException e) 
		{
			if (DEBUG)
			    System.err.println("Couldn't send request beacuse of Unknow Host Exception, request: "+request +" Error: "+e);
			return false;
		}      
		outDatagramPacket=new DatagramPacket( request.toBytes(), request.toBytes().length, destIPAddress, constants.TALK_PORT);
		try
		{
			theDatagramSocket.send(outDatagramPacket);
			return true;
		}
		catch (IOException e) 
		{
		    if (DEBUG)
		        System.err.println("IOException while sending request "+e);
		}
		return false;
	}
  
	ctl_response recieveResponse(String destIP)
	{
		ctl_response response=null;
		try 
		{	
			inDatagramPacket=new DatagramPacket(buffer, buffer.length);
			theDatagramSocket.setSoTimeout(RESEND_WAIT * 1000);
			theDatagramSocket.receive(inDatagramPacket);
			response=new ctl_response(inDatagramPacket.getData());
			if (!destIP.equals(inDatagramPacket.getAddress().getHostAddress()))
            {
                if (DEBUG)
                    System.err.println("Random reply "+inDatagramPacket.getAddress() + " at port " + inDatagramPacket.getPort() + " says \n" + response+"\n");      
                return null; // reply from some other host
            }
		}
		catch(InterruptedIOException timedOut)
		{
		    if (DEBUG)
			    System.err.println("Timed out to get respond from:"+ destIP);
			return null;
		}
		catch(SocketException se)
		{
			if (DEBUG)
			    System.err.println("Socket Exception "+se);
			return null;
		}
		catch (IOException e) 
		{	
			if (DEBUG)
			    System.err.println("IOException "+e);
			return null;
		} 
		return response;
	}
}
