// package jtalk;

import java.io.*;
import java.util.*;

public class configurations
{

    private String configurationFileName="jtalk.cfg";
    private RandomAccessFile theRandomAccessFile=null;
	private Vector theVector=new Vector();
	boolean DEBUG;
	
	public configurations(boolean DEBUG)
	{
	    this.DEBUG=DEBUG;
		theVector.addElement(new configurationsItem("JTalk_Timed_Out_Action", "int", DEBUG));
		theVector.addElement(new configurationsItem("Local_Accept_All", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Local_System_Name", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Local_Unlisted_Users_Not_Here", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Local_Aliases", "String", 1024, DEBUG));
		theVector.addElement(new configurationsItem("Local_Look_FontName", "String", 64, DEBUG));
		theVector.addElement(new configurationsItem("Local_Look_FontSize", "int", DEBUG));
		theVector.addElement(new configurationsItem("Local_Look_FontStyle", "int", DEBUG));
		theVector.addElement(new configurationsItem("Local_Look_ForegroundRed", "int", DEBUG));
		theVector.addElement(new configurationsItem("Local_Look_ForegroundGreen", "int", DEBUG));
		theVector.addElement(new configurationsItem("Local_Look_ForegroundBlue", "int", DEBUG));
		theVector.addElement(new configurationsItem("Local_Look_BackgroundRed", "int", DEBUG));
		theVector.addElement(new configurationsItem("Local_Look_BackgroundGreen", "int", DEBUG));
		theVector.addElement(new configurationsItem("Local_Look_BackgroundBlue", "int", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Use_Audio", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Loop_Sound", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Default_Alert", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Sound_Path", "String", 128, DEBUG));
		theVector.addElement(new configurationsItem("Remote_Use_Shortest_DNS", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Use_DNS", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Look_FontName", "String", 64, DEBUG));
		theVector.addElement(new configurationsItem("Remote_Look_FontSize", "int", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Look_FontStyle", "int", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Look_ForegroundRed", "int", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Look_ForegroundGreen", "int", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Look_ForegroundBlue", "int", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Look_BackgroundRed", "int", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Look_BackgroundGreen", "int", DEBUG));
		theVector.addElement(new configurationsItem("Remote_Look_BackgroundBlue", "int", DEBUG));
		theVector.addElement(new configurationsItem("Edit_Delete_Word_Byte", "byte", DEBUG));
		theVector.addElement(new configurationsItem("Edit_Delete_Word_Char", "char", DEBUG));
		theVector.addElement(new configurationsItem("Edit_Delete_Word_Modif", "int", DEBUG));
		theVector.addElement(new configurationsItem("Edit_Delete_Line_Byte", "byte", DEBUG));
		theVector.addElement(new configurationsItem("Edit_Delete_Line_Char", "char", DEBUG));
		theVector.addElement(new configurationsItem("Edit_Delete_Line_Modif", "int", DEBUG));
		theVector.addElement(new configurationsItem("Edit_Number_Of_Spaces_Per_TAB", "int", DEBUG));
		theVector.addElement(new configurationsItem("Edit_Wrap_Every", "int", DEBUG));
		theVector.addElement(new configurationsItem("Edit_Warp", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Edit_Delete_Previous_Lines", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Advanced_Max_Time", "int", DEBUG));
		theVector.addElement(new configurationsItem("Advanced_Max_Wait", "int", DEBUG));
		theVector.addElement(new configurationsItem("Advanced_URL", "String", 128, DEBUG));
		theVector.addElement(new configurationsItem("Advanced_Port", "int", DEBUG));
		theVector.addElement(new configurationsItem("Advanced_SMTP_Server", "String", 128, DEBUG));
		theVector.addElement(new configurationsItem("Advanced_Daemon_Port", "int", DEBUG));
		theVector.addElement(new configurationsItem("Answer_Normal_Mode", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Answer_Forward_Email", "String", 128, DEBUG));
		theVector.addElement(new configurationsItem("Answer_Forward_To_Email", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Message_Normal", "String", 1024, DEBUG));
		theVector.addElement(new configurationsItem("Message_Answer_Machine", "String", 1024, DEBUG));
		theVector.addElement(new configurationsItem("Message_Fortune", "String", 1024, DEBUG));
		theVector.addElement(new configurationsItem("Fortune_File_Path", "String", 128, DEBUG));
		theVector.addElement(new configurationsItem("Fortune_Message_Separator", "String", 128, DEBUG));
		theVector.addElement(new configurationsItem("Fortune_Comment_Indicator", "String", 128, DEBUG));
		theVector.addElement(new configurationsItem("Debug", "boolean", DEBUG));
		theVector.addElement(new configurationsItem("Debug_File_Path", "String", 128, DEBUG));
		
	}
	
	private int getOffset(int index)
	{
		int offset=0;
		for (int i=0; i<index; i++)
		{
			offset+=((configurationsItem)theVector.elementAt(i)).length();
		}
		return offset;
	}

	public void openConfigurationFile()
	{
		try  
        {   
          theRandomAccessFile= new RandomAccessFile(configurationFileName, "rw");   
		}
		catch(Exception exception)  
        {
            if(DEBUG)
                System.err.println("Error with opening configuration file for writing. Due to :" +exception);
        }
	}

	public void closeConfigurationFile()
	{
		try
		{
			theRandomAccessFile.close();
        }
        catch(IOException exception)  
        {   
            if(DEBUG)
                System.err.println("Couldn't close configuration file. Due to :"+exception.toString());   
        }   
    }

	private int getIndex(String item)
	{
		int index=-1;
		for (int i=0; i < theVector.size(); i++)
		{
			if (((configurationsItem)theVector.elementAt(i)).getName().equals(item))
			{
				index=i;
				break;
			}
		}
		if (index<0)
		{
			if(DEBUG)
			    System.err.println("Error! Item not found: "+ item);
		}
		return index;
	}
	
	public void saveData(String  item, Object object)
    {
			saveDataByIndex(getIndex(item), object);
	}
	
	private void saveDataByIndex(int index, Object object)
    {
        try  
        {
		    int offset=getOffset(index);
            if (theRandomAccessFile.length()<offset)
            {
                for(long i=theRandomAccessFile.length(); i<offset; i++)
                         theRandomAccessFile.write(0x0);
            }
            else
               theRandomAccessFile.seek(offset);  
			
			String type=((configurationsItem)theVector.elementAt(index)).getType();
			if(type.equals("byte"))
			{
				theRandomAccessFile.writeByte(((Byte)object).intValue());
			}
			else if(type.equals("boolean"))
			{
				theRandomAccessFile.writeBoolean(((Boolean)object).booleanValue());
			}
			else if(type.equals("char"))
			{
				theRandomAccessFile.writeChar(((Character)object).charValue());
			}
			else if(type.equals("int"))
			{
				theRandomAccessFile.writeInt(((Integer)object).intValue());
			}
			else // if(type.equals("String"))
			{
			    byte[] temp=new byte[((configurationsItem)theVector.elementAt(index)).length()];
			    byte[] theObject=((String)object).getBytes();
				System.arraycopy(theObject, 0, temp, 0, Math.min(temp.length, theObject.length));
				theRandomAccessFile.write(temp);
			}
         
        }
        catch(IOException exception)  
        {   
            if(DEBUG)
                System.err.println("Couldn't write configuration file. Due to :"+exception);   
        }   
    }
	
	public boolean isValidConfigurationsFile()
    {
		long length=0;
		length=getOffset(theVector.size())+1;
		try
		{
			return (theRandomAccessFile.length()==length);
		}
		catch(IOException exception)  
		{   
		    if(DEBUG)
		        System.err.println("Couldn't check configuration file for validation. Due to :"+exception);   
			return false;
	    }   
	}
	
	public void validateConfigurationsFile()
    {
		try  
        {
		    int offset=getOffset(theVector.size());
            if (theRandomAccessFile.length()<offset)
            {
				if(DEBUG)
				{
				    System.err.println("The configuration file is not ready to be validated.");   
				    System.err.println("Because the file length is: "+ theRandomAccessFile.length() + " when is should be: "+ offset);   
				}
            }
            else
			{
				theRandomAccessFile.seek(offset);  
				theRandomAccessFile.writeByte(0xFF);
			}
		}
		catch(IOException exception)  
		{   
		    if(DEBUG)
		        System.err.println("Couldn't validate configuration file. Due to :"+exception);   
	    }   
        
	}

	public Object getData(String item)
    {
			return (getDataByIndex(getIndex(item)));
	}
	
	private Object getDataByIndex(int index)
    {
        try  
        {
		    int offset=getOffset(index);
            if (theRandomAccessFile.length()<offset)
            {
                return null;
            }
            else
			{
			    theRandomAccessFile.seek(offset);
				String type=((configurationsItem)theVector.elementAt(index)).getType();
				if(type.equals("byte"))
				{
					return (new Byte(theRandomAccessFile.readByte()));
				}
				else if(type.equals("boolean"))
				{
					return (new Boolean(theRandomAccessFile.readBoolean()));
				}
				else if(type.equals("char"))
				{
					return (new Character(theRandomAccessFile.readChar()));
				}
				else if(type.equals("int"))
				{
					return (new Integer(theRandomAccessFile.readInt()));
				}
				else //if(type.equals("String"))
				{
					byte[] temp=new byte[((configurationsItem)theVector.elementAt(index)).length()];
					theRandomAccessFile.readFully(temp);
					String str=new String(temp);
					str=str.substring(0, str.indexOf(0x0));
					return (str);
				}
			}
		}
        catch(IOException exception)  
        {   
            if (DEBUG)
                System.err.println("Couldn't read configuration file. Due to :"+exception);   
			return null;
        }   
    }		

}