// package jtalk;

/** talk daemon compatible with unix ntalk (udp/ip port 518) */
public class constants
{
	public static boolean DEBUG=false;
    public static boolean FORK=true;
	public static int BUILD=100;
	
	/** protocol version */
	public static final  byte TALK_VERSION		= 1;
	/** protocol port */
	public static final  int TALK_PORT			= 518; //*
	/** ip family version */
	public static final  char AF_INET			= 2;	
	/** length of ctl_msg */
	public static final  int CTL_MSG_LENGTH		= 84;
	/** length of ctl_response */
	public static final  int CTL_RESPONSE_LENGTH= 32;
	
/** message type values */
	/** leave invitation with server */
	public static final  byte LEAVE_INVITE		= 0;	
	/** check for invitation by callee */
	public static final  byte LOOK_UP			= 1;	
	/** delete invitation by caller */
	public static final  byte DELETE			= 2;	
	/** announce invitation by caller */
	public static final  byte ANNOUNCE			= 3;	

/** answer values */
	/** operation completed properly */
	public static final  byte SUCCESS			= 0;	
	/** callee not logged in */
	public static final  byte NOT_HERE			= 1;	
	/** operation failed for unexplained reason */
	public static final  byte FAILED			= 2;	
	/** caller's machine name unknown */
	public static final  byte MACHINE_UNKNOWN	= 3;	
	/** callee's tty doesn't permit announce */
	public static final  byte PERMISSION_DENIED	= 4;	
	/** request has invalid type value */
	public static final  byte UNKNOWN_REQUEST	= 5;
	/** request has invalid protocol version */
	public static final  byte BADVERSION		= 6;	
	/** request has invalid addr value */
	public static final  byte BADADDR			= 7;	
	/** request has invalid ctl_addr value */
	public static final  byte BADCTLADDR		= 8;
	

/** Operational parameters. */
	/** MAX_LIFE max time daemon saves invitations */
	public static final  int MAX_LIFE			= 60;
/** RING_WAIT should be 10's of seconds less than MAX_LIFE */
	/** RING_WAIT time to wait before resending invitation */
	public static final  int RING_WAIT			= 30;	
	/** RESEND_WAIT time to wait for response before resending a udp packet */
	public static final  int RESEND_WAIT		= 10;	
	/** MAX_ID = 2^15 so I don't have sign troubles */
	public static final  int MAX_ID				= 32767;
	/** MAX_TRIES max number of time to resend the packet before giving up */
	public static final  int MAX_TRIES			= 10;
	/** MAX_CHARS_PER_LINE max number of characters per line (before it's wraps to the next line */
	static final int MAX_CHARS_PER_LINE=80;
	/** NUM_OF_SPACES_PER_TAB number of spaces per tab	 */
	static final int NUM_OF_SPACES_PER_TAB=8;
	/** WARP to wrap if lines growes longer than MAX_CHARS_PER_LINE */
	static final boolean WARP=true;
	/**	DELETE_PREVIOUSE_LINES allow deleting preveous lines? */
	static final boolean DELETE_PREVIOUSE_LINES=false;

	static final byte BACKSPACE=(byte)java.awt.event.KeyEvent.VK_BACK_SPACE;
	static final byte DELETE_WORD=21;
	static final char DELETE_WORD_CHAR=(char)java.awt.event.KeyEvent.VK_U;
    static final int DELETE_WORD_MODIF=java.awt.Event.CTRL_MASK;
	static final byte DELETE_LINE=23;
    static final char DELETE_LINE_CHAR=(char)java.awt.event.KeyEvent.VK_W;
    static final int DELETE_LINE_MODIF=java.awt.Event.CTRL_MASK;
    
    static final int SHIFT_MODIF=32;
    static final int CTRL_MODIF=96;
    
    

    /** answering machine specific*/	
	static final String ANSWER_MACHINE_FILENAME_PREFIX="jtalk";
	static final String ANSWER_MACHINE_FILENAME_SUFFIX="msg";
	static final String ANSWER_MACHINE_WARNING="This file is generated by JTalk. DON'T EDIT IT!";
	static final String ANSWER_MACHINE_FROM="Message From: ";
	static final String ANSWER_MACHINE_DATE="Date Stamp: ";
	static final String ANSWER_MACHINE_STATUS="Status: ";
	static final String ANSWER_MACHINE_SUBJECT="JTalk. message from: ";
	
	static final String ADDRESS_BOOK_WARNING="This is an address book generated by JTalk. DO NOT EDIT!";
	
	static final String SAVE_MESSAGE_WARNING="This file is generated by JTalk.";
	static final String SAVE_MESSAGE_LOCAL_WINDOW="LOCAL WINDOW: ";
	static final String SAVE_MESSAGE_REMOTE_WINDOW="REMOTE WINDOW: ";
	static final String SAVE_MESSAGE_SEPERATOR="\n\r~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\r";
	
/** jtalk specific parameters */
	/** message that is send every time connection is established */
	public static final String MESSAGE_NORMAL="Hello, you are talking to JTalk.\n";
	public static final String MESSAGE_FORTUNE="Did you know?!";
	public static final String MESSAGE_ANSWER_MACHINE="Leave a message after the beep. BEEP!\n";
    public static final String FORTUNE_COOKIE="No joke for you\n\t M. Duchovny";
    public static final String JTALK_CHAT_TITLE="JTalk Beta ";
    public static final String[] ACTION_CHOICES=
    {
        "Accept",
        "Not Here",
        "Refuse",
        "Answer M.",
        "Fortune",
        "Ignore"
    };	

    public static final int DEFAULT_ACTION=2;
    
    public static final int TALK_MODE_NORMAL=0;
    public static final int TALK_MODE_ANSWER_MACHINE=1;
    public static final int TALK_MODE_FORTUNE=2;
    
    	
/** debug info */

    
	public static final String[] RESPONSE=
	{
		"success",
		"the user is not logged on",
		"failed for unknow reason",
		"remote machine doesn't understand our internet address (IP)",
		"premission denied to talk to remote user",
		"remote machine doesn't understand our request",
		"remote machine doesn't understand our talk version",
		"remote machine doesn't understand our internet address (TCP/IP)",
		"remote machine doesn't understand our internet address (UDP/IP)",
		"invalid answer recieved"
	};

	public static final String[] REQUEST=
	{
		"LEAVE INVITE",
		"LOOK UP",
		"DELETE",
		"ANNOUNCE"
	};
}

