 // package jtalk;


/**
 * Client->Server request message format.
 */
public class ctl_msg 
{
	public final int NAME_SIZE	   =12;
	public final int TTY_SIZE      =16;
	
	public int localPort;

	
	/** protocol version */
	public final byte	vers=constants.TALK_VERSION;
	/** request type, see below */
	public byte			type;	
	/** padding */  
	public final char	pad=00;					
	/** message id */ 
	public int			id_num;					
	/** tcp/ip address */
	public osockaddr	addr;					
	/** upd/ip address */
	public osockaddr	ctl_addr;				
	/** caller's process id */
	public int			pid;					 
	/** caller's name */
	public byte[]	l_name=new byte[NAME_SIZE];	
	/** callee's name */
	public byte[]	r_name=new byte[NAME_SIZE];	
	/** callee's tty name */
	public byte[]	r_tty=new byte[TTY_SIZE];
	
	ctl_msg()
	{
		this.addr=new osockaddr();
		this.ctl_addr=new osockaddr();
		
	}
	
	ctl_msg(byte[] bytes)
	{
		if (bytes.length!=constants.CTL_MSG_LENGTH)
			System.exit(1);
		int pointer=1;
		type=bytes[pointer++];
		pointer+=2;
		id_num=(((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++])*16777216+
				((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++])*65536+
				((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++])*256+
				((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++]));	   
		addr=new osockaddr(bytes, pointer);
		pointer+=16;
		ctl_addr=new osockaddr(bytes, pointer);
		pointer+=16;
		pid=(((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++])*16777216+
				((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++])*65536+
				((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++])*256+
				((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++]));
		System.arraycopy(bytes, pointer, l_name, 0, NAME_SIZE);
		pointer+=NAME_SIZE;
		System.arraycopy(bytes, pointer, r_name, 0, NAME_SIZE);
		pointer+=NAME_SIZE;	
		System.arraycopy(bytes, pointer, r_tty, 0, TTY_SIZE);
		pointer+=TTY_SIZE;	
	}
	
	public byte[] toBytes()
	{
		int pointer=0;
		byte[] bytes=new byte[84];
		
		bytes[pointer++]=this.vers;
		
		bytes[pointer++]=this.type;
		
		bytes[pointer++]=0;
		bytes[pointer++]=0;
	
		bytes[pointer++]=(byte)(this.id_num/16777216);
		bytes[pointer++]=(byte)((this.id_num<<8)/16777216);
		bytes[pointer++]=(byte)((this.id_num<<16)/16777216);
		bytes[pointer++]=(byte)((this.id_num<<24)/16777216);
		
		
		bytes[pointer++]=(byte)(this.addr.family/256);
		bytes[pointer++]=(byte)(this.addr.family%256);
		
		bytes[pointer++]=(byte)(this.addr.port/256);
		bytes[pointer++]=(byte)(this.addr.port%256);
		
		bytes[pointer++]=(byte)(this.addr.ip/16777216);
		bytes[pointer++]=(byte)((this.addr.ip<<8)/16777216);
		bytes[pointer++]=(byte)((this.addr.ip<<16)/16777216);
		bytes[pointer++]=(byte)((this.addr.ip<<24)/16777216);
		
				
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
	

		bytes[pointer++]=(byte)(this.ctl_addr.family/256);
		bytes[pointer++]=(byte)(this.ctl_addr.family%256);
		
		bytes[pointer++]=(byte)(this.ctl_addr.port/256);
		bytes[pointer++]=(byte)(this.ctl_addr.port%256);
		
		bytes[pointer++]=(byte)(this.ctl_addr.ip/16777216);
		bytes[pointer++]=(byte)((this.ctl_addr.ip<<8)/16777216);
		bytes[pointer++]=(byte)((this.ctl_addr.ip<<16)/16777216);
		bytes[pointer++]=(byte)((this.ctl_addr.ip<<24)/16777216);		
				
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		bytes[pointer++]=0;
		

//		bytes[pointer++]=(byte)(this.pid/16777216);
//		bytes[pointer++]=(byte)((this.pid<<8)/16777216);
//		bytes[pointer++]=(byte)((this.pid<<16)/16777216);
//		bytes[pointer++]=(byte)((this.pid<<24)/16777216);

		int tmpPid=this.pid;
		int i1,i2,i3,i4;
		i4=tmpPid%256;
		tmpPid/=256;
		i3=tmpPid%256;
		tmpPid/=256;
		i2=tmpPid%256;
		tmpPid/=256;
		i1=tmpPid%256;
		tmpPid/=256;
		bytes[pointer++]=(byte)i1;
		bytes[pointer++]=(byte)i2;
		bytes[pointer++]=(byte)i3;
		bytes[pointer++]=(byte)i4;
		
				
		
		System.arraycopy(this.l_name, 0, bytes, pointer, this.l_name.length);
		pointer+=NAME_SIZE;
		
		System.arraycopy(this.r_name, 0, bytes, pointer, this.r_name.length);
		pointer+=NAME_SIZE;
		
		System.arraycopy(this.r_tty, 0, bytes, pointer, this.r_tty.length);
		pointer+=TTY_SIZE;
		
		return bytes;
	}
	
	public String toString()
	{
		String string="";
		string+="Vers "+this.vers+"\n";
		string+="Type "+constants.REQUEST[this.type]+"\n";	
		string+="id_num "+this.id_num+"\n";	
		string+="family "+(int)this.addr.family+"\n";
		string+="port "+(int)this.addr.port+"\n";
		string+="IP address "+getRemoteDNS()+"\n";
		string+="family "+(int)this.ctl_addr.family+"\n";
		string+="port "+(int)this.ctl_addr.port+"\n";
		string+="IP address "+this.ctl_addr.ip+"\n";
		string+="pid "+this.pid+"\n";
		string+="caller's name "+getCallerName()+"\n";
		string+="callee's name "+getCalleeName()+"\n";
		return string;
	}
    
	public String getCalleeName()
	{
		String temp=new String(this.r_name);
		if (temp.indexOf("\0")!=-1)
			temp=temp.substring(0, temp.indexOf("\0"));
		temp.trim();
		return temp;
	}
		
	public String getCallerName()
	{
		String temp=new String(this.l_name);
		if (temp.indexOf("\0")!=-1)
			temp=temp.substring(0, temp.indexOf("\0"));
		temp.trim();
		return temp;
	}
	
	public String getRemoteDNS()
	{
		return getIPorDNS.getDNS(this.addr.ip);
	}

	public String getLocalDNS()
	{
		return getIPorDNS.getLocalDNS();
	}

	public int getCalleePortTCP()
	{
		return this.addr.port;
	}
	public int getCalleePortUDP()
	{
		return this.ctl_addr.port;
	}
}
