// package jtalk;


/**
 * Server->client response message format.
 */
 
public class ctl_response 
{
	/** protocol version */
	public byte	vers;			
	/** type of request message, see below */
	public byte	type;			
	/** respose to request message, see below */
	public byte	answer;
	/** padding */
	public final byte	pad=0;	
	/** message id */
	public int	id_num;
	/** tcp/ip address for establishing conversation */
	public osockaddr addr;
	
	ctl_response()
	{
		this.addr=new osockaddr();
	}
	ctl_response(byte[] bytes)
	{
		if (bytes.length != constants.CTL_RESPONSE_LENGTH)
			System.exit(1);
		int pointer=0;
		vers=bytes[pointer++];
		type=bytes[pointer++];
		answer=bytes[pointer++];
		pointer++;
		id_num=(((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++])*16777216+
				((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++])*65536+
				((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++])*256+
				((bytes[pointer]<0)?bytes[pointer++]+256:bytes[pointer++]));	   
		addr=new osockaddr(bytes, pointer);
	}
	
	public byte[] toBytes()
	{
		int pointer=0;
		byte[] bytes=new byte[24];
		
		bytes[pointer++]=this.vers;
		
		bytes[pointer++]=this.type;
		
		bytes[pointer++]=this.answer;
		
		bytes[pointer++]=this.pad;
	
		bytes[pointer++]=(byte)(this.id_num/16777216);
		bytes[pointer++]=(byte)((this.id_num<<8)/16777216);
		bytes[pointer++]=(byte)((this.id_num<<16)/16777216);
		bytes[pointer++]=(byte)((this.id_num<<24)/16777216);
		
		
		bytes[pointer++]=(byte)(this.addr.family/256);
		bytes[pointer++]=(byte)(this.addr.family%256);
		
		bytes[pointer++]=(byte)(this.addr.port/256);
		bytes[pointer++]=(byte)(this.addr.port%256);
		
		bytes[pointer++]=(byte)(this.addr.ip/16777216);
		bytes[pointer++]=(byte)((this.addr.ip<<8)/16777216);
		bytes[pointer++]=(byte)((this.addr.ip<<16)/16777216);
		bytes[pointer++]=(byte)((this.addr.ip<<24)/16777216);
		
		System.arraycopy(this.addr.pad, 0, bytes, pointer, 8);
		pointer+=8;
		
		return bytes;
	}
	
	public String toString()
	{
		String string="";
		string+="Vers "+this.vers+"\n";
		string+="Type "+constants.RESPONSE[this.type]+"\n";	
		string+="Answer "+this.answer+"\n";	
		string+="id_num "+this.id_num+"\n";	
		string+="family "+(int)this.addr.family+"\n";
		string+="port "+(int)this.addr.port+"\n";
		string+="IP address "+this.addr.ip+"\n";
		return string;
	}
	
	public String getHost()
	{
		return getIPorDNS.getDNS(this.addr.ip);
	}
} 
