 // package jtalk;

/** Sends an email to the given email address using the given SMPT Server  */

import java.net.*;
import java.io.*;
import java.awt.*;
import javax.swing.*;

public class email 
{
	private String toEmail = null;
	private String fromEmail = null;
	private String theSubject = null;
	private String theData = null;
    private String theServer = "";
	
	private final int smtpPort = 25;
	private boolean DEBUG=true;
	private boolean changed=false;
	
	private Socket socket;
	private DataOutputStream theDataOutputStream;
	private BufferedReader theBufferedReader;
	


	/**
	 * Main routine, for standalone program execution
	 */
	public static void main(String args[])
	{
		email theSendMail=null;
		if (args.length<1)
		{
			System.err.println("Usage: sendMail SMTP_SERVER [DEBUG]");
			System.err.println("then send(from, to, subject, data) or send(from, to, data) or send(to, data)");
			System.exit(1);
		}
		else if  (args.length==1)
		{
			theSendMail = new email(args[0], false);
		}
		else
		{
			theSendMail = new email(args[0], true);
		}
	}

	public email(boolean DEBUG)
	{
		this.DEBUG=DEBUG;
        
        configurations theConfigurations=new configurations(DEBUG);
		theConfigurations.openConfigurationFile();
	    if(theConfigurations.isValidConfigurationsFile())
        {
            theServer=(String)theConfigurations.getData("Advanced_SMTP_Server");
	    }
		theConfigurations.closeConfigurationFile();
		
		//{{INIT_CONTROLS
		//}}
	}

	public email(String server, boolean DEBUG)
	{
		this.DEBUG=DEBUG;
		this.theServer=server;
	}
	
	/**
	 * Send an e-mail message. 
	 *  with no subject and from "system user" at "this machine"
	 */
	public boolean send(String to, String data)
	{
		String from= "" + System.getProperty("user.name") + "@"+getIPorDNS.getLocalDNS();
		return send(from, to, null, data);
	}

	/**
	 * Send an e-mail message. 
	 *  with no subject 
	 */
	public boolean send(String from, String to, String data)
	{
		return send(from, to, null, data);
	}
	
	/**
	 * Send an e-mail message. 
	 */
	public boolean send(String from, String to, String subject, String data)
	{
		this.toEmail=to;
		this.fromEmail=from;
		this.theSubject=subject;
		this.theData=data;
		
		return sendIt();
	}
	
	private boolean sendIt()
	{
//	    theServer="mail.netzero.net";
	    
		// Open connection to SMTP server
		// Send the form contents as a message
		while (socket==null)
		{
		    try
		    {
    			socket = new Socket(theServer, smtpPort);
    		}
    		catch (IOException ioex)
		    {
		        Object result=JOptionPane.showInputDialog(null, "Enter a valid SMTP server:", "SMTP SERVER ERROR!", JOptionPane.ERROR_MESSAGE, null, null, theServer);
                if (result==null)
        		 {
                    System.err.println("Aborted by user.");
        		    return true;
        		 }
        		 if (theServer!=result.toString())
        		 {
        		    changed=true;
        		    theServer=result.toString(); 
        		 }
		    }
		}
		try
	    {
   		    theDataOutputStream = new DataOutputStream(socket.getOutputStream());
   		    theBufferedReader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
    		String reply = theBufferedReader.readLine();
    	    if (DEBUG)
	    	    System.out.println("sendLine in: " + reply);
	    	if (reply.indexOf("220")<0)
	    	{
	    	    Toolkit.getDefaultToolkit().beep();
    	        JOptionPane.showMessageDialog(null,
    	        "Couldn't connect to the SMTP server.",
    	        "JTalk Email Error", 
    	        JOptionPane.ERROR_MESSAGE);
	    	    return false;
	    	}
   			reply=sendLine("HELO " + getIPorDNS.getLocalIP());
	    	if (reply.indexOf("250")<0)
	    	{
	    	    Toolkit.getDefaultToolkit().beep();
    	        JOptionPane.showMessageDialog(null,
    	        "Couldn't initialize the SMTP server.",
    	        "JTalk Email Error", 
    	        JOptionPane.ERROR_MESSAGE);
	    	    return false;
	    	}
   			// Send message
    		reply=sendLine("MAIL FROM:" + fromEmail);
   			if (reply.indexOf("250")<0)
	    	{
	    	    Toolkit.getDefaultToolkit().beep();
    	        JOptionPane.showMessageDialog(null, 
    	        "Couldn't set sender field.",
    	        "JTalk Email Error", 
    	        JOptionPane.ERROR_MESSAGE);
	    	    return false;
	    	}
   			reply=sendLine("RCPT TO:" + toEmail);
    		if (reply.indexOf("250")<0 && reply.indexOf("251")<0)
	    	{
	    	    Toolkit.getDefaultToolkit().beep();
    	        JOptionPane.showMessageDialog(null, 
    	        "Couldn't set reciever field.",
    	        "JTalk Email Error", 
    	        JOptionPane.ERROR_MESSAGE);
	    	    return false;
	    	}
   			reply=sendLine("DATA");
            if (reply.indexOf("354")<0)
	    	{
	    	    Toolkit.getDefaultToolkit().beep();
    	        JOptionPane.showMessageDialog(null, 
    	        "Couldn't set email message.",
    	        "JTalk Email Error", 
    	        JOptionPane.ERROR_MESSAGE);
	    	    return false;
	    	}
   			String Data="";
            if (theSubject!=null && theSubject.length()>0)
    		    Data="Subject: " + theSubject+"\r\n";
    		Data+="FROM:" + fromEmail+"\r\n";
   			Data+="TO:" + toEmail+"\r\n";
    		Data+=theData+"\r\n.";
			reply=sendLine(Data);
			if (reply.indexOf("250")<0)
	    	{Toolkit.getDefaultToolkit().beep();
    	        JOptionPane.showMessageDialog(null, 
    	        "SMTP server didn't accept email message.",
    	        "JTalk Email Error", 
    	        JOptionPane.ERROR_MESSAGE);
	    	    return false;
	    	}
   			sendLine("QUIT");

    		// Close connection
	        socket.close();
		}
		catch (Exception ex)
		{
			System.err.println("Mail Error! "+ ex);
		}
        if(changed)
        {
            updateSMTPserver();
        }
        
        return true;

	}

	/** Send a line of data to the server, and retrieve the handshake */
	private String sendLine(String data) throws IOException
	{
		if (DEBUG)
			System.out.println("sendLine out: " + data);
		theDataOutputStream.writeBytes(data);
		theDataOutputStream.writeBytes("\r\n");
		theDataOutputStream.flush();
		String reply="", readBuffer;
		while ((readBuffer = theBufferedReader.readLine())!=null)
		{
		    reply = readBuffer;
		}
		if (DEBUG)
			System.out.println("sendLine in: " + reply);
		return reply;
	}
	
	private void updateSMTPserver()
	{
	    configurations theConfigurations=new configurations(DEBUG);
		theConfigurations.openConfigurationFile();
	
	    if(theConfigurations.isValidConfigurationsFile())
        {
            theConfigurations.saveData("Advanced_SMTP_Server", theServer);
	    }
		theConfigurations.closeConfigurationFile();
	}
	
	

	//{{DECLARE_CONTROLS
	//}}
}
