// package jtalk;

import java.io.*;
import javax.swing.*;

class fortune
{
	private BufferedReader theBufferedReader=null;
	private long FileLength=0;
	private String separator="", commentSeparator="";
	private File theFile=null;
	private boolean isValidFortune=false;
	boolean DEBUG;
	
    public fortune(boolean DEBUG)
	{
	    configurations theConfigurations=new configurations(DEBUG);
		theConfigurations.openConfigurationFile();
	    if(theConfigurations.isValidConfigurationsFile())
    	{
	        String filePath=(String)theConfigurations.getData("Fortune_File_Path");
	        separator=(String)theConfigurations.getData("Fortune_Message_Separator");
	        commentSeparator=(String)theConfigurations.getData("Fortune_Comment_Indicator");
	        if (filePath!=null && filePath.length()>0 && (theFile=new File(filePath)).exists())
		    {
	            isValidFortune=true;
	            FileLength=theFile.length();
		    }
		}
		theConfigurations.closeConfigurationFile();
		
		//{{INIT_CONTROLS
		//}}
	}
	
	boolean rendomSeek()
	{
		reset();
		if (theBufferedReader==null) 
		    return false;
		double random_number=Math.random();
		long seek_number=(long)Math.round(random_number*FileLength);
		try
		{
			theBufferedReader.skip(seek_number);
		}
		catch (IOException e)
		{
            if(DEBUG)
                System.err.println("Unable to seek in fortune file "+e);
		}
		String line=null;
		try
		{
			int numBytesRead=0;
			while (((line=theBufferedReader.readLine())!=null)&&!(line.equals(separator)))
			{
				numBytesRead+=line.length()+1;
			}
			if ((line==null)||(seek_number+numBytesRead==FileLength-1))
				return false;
		}
		catch (IOException e)
		{
		    if(DEBUG)
		        System.err.println("Unable to read from fortune file "+e);
		}
		return true;
	}
	
	private void reset()
	{
		try
		{
			theBufferedReader = new BufferedReader(new InputStreamReader(new FileInputStream(theFile)));
		}
		catch (FileNotFoundException e)
		{
			if(DEBUG)
			    System.err.println("Fortune file not found "+e);
		}
	}
	
	public void showFortune()
	{
	    new FortuneDialog(this);
	}
	
	public String getMessage()
	{
	    if (!isValidFortune)
	    {
	        return constants.FORTUNE_COOKIE;
	    }
		while (!rendomSeek())
		{
		}
		String message=new String();
		String line=null;
		try
		{
			while (((line=theBufferedReader.readLine())!=null)&&!(line.equals(separator)))
			{
				if (line.startsWith(commentSeparator)) 
				    break;
				message+=line+='\n';
			}
		}
		catch (IOException e)
		{
			if(DEBUG)
			    System.err.println("Unable to read from fortune file "+e);
		}
		if (line!=null && line.startsWith(commentSeparator)) 
		    getMessage();
		return message;
	}
	//{{DECLARE_CONTROLS
	//}}
}
