 // package jtalk;

import java.io.*;
import java.net.*;
import java.util.*;

public class getIPorDNS
{
	public static String getLocalIP()
	{
		Socket socket=null;
		configurations theConfigurations=new configurations(false);
		theConfigurations.openConfigurationFile();
	
	    try //internet ip
		{
			if(theConfigurations.isValidConfigurationsFile())
			{
				socket = new Socket((String)theConfigurations.getData("Advanced_URL"),
									   ((Integer)theConfigurations.getData("Advanced_Port")).intValue());
			}
			else
			{
				socket = new Socket("yucs.org", 80);
			}		
				theConfigurations.closeConfigurationFile();
				String localIP=socket.getLocalAddress().getHostAddress();
				socket.close();
				return localIP;
			}
			catch(UnknownHostException uhe)  // local network ip
			{
				try
				{
				return (InetAddress.getLocalHost().getHostAddress());
				}
				catch(UnknownHostException anotheruhe) //that's is odd
				{
					return null;
				}
	
			}
			catch(IOException ioe)
			{
				return null;
			}
	}
	
	public static String getLocalDNS()
	{
		return getDNS(getLocalIP());
	}
	
	public static String getDNS(String IP)
	{
		InetAddress[] DNS=null;
		String theDNS=IP;
		if (getData(0))
		{
			try
			{
				DNS=InetAddress.getAllByName(IP);
			}
			catch (UnknownHostException e)
			{
			    return IP;
			}
	
			theDNS= DNS[0].getHostName();
			if (getData(1))
			{
				for (int i=1; i<DNS.length; i++) //get the shortes dns
				{
					if (theDNS.length()> DNS[i].getHostAddress().length())
						theDNS= DNS[i].getHostName();
				}
			}
		}
		return theDNS;
	}

	public static String getDNS(long IP)
	{
		return (getDNS(dotlessToIP(IP)));
	}
	
	public static String dotlessToIP(long dotlessIP)
	{
		String ip="";
		byte temp;
		temp=(byte)(dotlessIP/16777216);
		ip+=(temp<0)?(temp+256):temp;
		ip+=".";
		temp=(byte)((dotlessIP<<8)/16777216);
		ip+=(temp<0)?(temp+256):temp;
		ip+=".";
		temp=(byte)((dotlessIP<<16)/16777216);
		ip+=(temp<0)?(temp+256):temp;
		ip+=".";
		temp=(byte)((dotlessIP<<24)/16777216);
		ip+=(temp<0)?(temp+256):temp;
		return ip;
	}
	
	public static long ipToDotless(String ip)
	{
		long dotless=0;
		StringTokenizer stringTokenizer=new StringTokenizer(ip, ".");
		for (double power=3; power>=0; power--)
			dotless+=(new Double(stringTokenizer.nextToken()).doubleValue())*Math.pow(256,power);
		return dotless;
	}
	
	public static boolean getData(int mode)
	{
		boolean b=true;
		configurations theConfigurations=new configurations(false);
		theConfigurations.openConfigurationFile();
	
	    if(theConfigurations.isValidConfigurationsFile())
		{
			if (mode==0)
				b=((Boolean)theConfigurations.getData("Remote_Use_DNS")).booleanValue();
			else if(mode==1)
				b=((Boolean)theConfigurations.getData("Remote_Use_Shortest_DNS")).booleanValue();
		}
		theConfigurations.closeConfigurationFile();
		return b;
	}
}
