// package jtalk;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

public class jtableWithSort extends JTable implements MouseMotionListener, MouseListener
{
	jtableModel theModel;
	TableCellRenderer HeaderRenderer;
	int ColumnToSort;
	int ColumnSelected=-1;
	int ColumnInFocus=-1;

	boolean AscendingSort;
	int indexes[];

	public jtableWithSort(jtableModel theModel)
	{
		super();
		this.theModel=theModel;
        setOpaque(false);
		super.setOpaque(false);
		indexes=null;
		ColumnToSort=0;
		AscendingSort=true;
		doSort();
        setModel(theModel);
        setBackground(Color.white);
	    setSelectionBackground(Color.cyan);
	    setSelectionForeground(Color.magenta);
	    
       
		TableColumn Current;
		HeaderRenderer=new CustomHeaderRenderer();
		for (Enumeration Cols=getColumnModel().getColumns();Cols.hasMoreElements();)
		{
		    Current=(TableColumn)Cols.nextElement();
			Current.setHeaderRenderer(HeaderRenderer);
		}
		getTableHeader().addMouseListener(this);
		getTableHeader().addMouseMotionListener(this);
		getTableHeader().setReorderingAllowed(false);              
	
		//{{INIT_CONTROLS
		setSize(0,0);
		//}}
	}

    public Component prepareRenderer(TableCellRenderer renderer, int row, int column) 
	{
	    Component c = super.prepareRenderer( renderer, row, column);
		// We want renderer component to be transparent so background image is visible
//		if( c instanceof JComponent )
//		    ((JComponent)c).setOpaque(false);
         return c;
	}
  
	public void removeRow(int row)
    {
        if (indexes!=null)
        {
            row=indexes[row];
	        indexes=null;
	    }
        theModel.removeRow(row);
    }
    
    public Object getValueAt(int row, int col) 
	{
        if (indexes!=null)
            row=indexes[row];
	    return theModel.getValueAt(row, col);
    }
     
    public void setValueAt(Object value, int row, int col) 
	{
        if (indexes!=null)
            row=indexes[row];
	    theModel.setValueAt(value, row, col);
    }

    public Object[][] getData()
    {
        return theModel.data;
    }
    
    public void cellUpdated(int row, int col)
    {
        if (indexes!=null)
            row=indexes[row];
        theModel.cellUpdated(row, col); 
    }


    public void tableChanged()
    {
        indexes=null;
        theModel.tableChanged(new TableModelEvent(theModel, TableModelEvent.ALL_COLUMNS, TableModelEvent.UPDATE)); 
		
    }
    
    public void addRow()
    {
       indexes=null;
       theModel.addRow();
    }

    public void addRow(Object[] initialValues)
    {
       indexes=null;
       theModel.addRow(initialValues);
    }

    
    public int getIndex(int row)
    {
        if (indexes!=null)
            row=indexes[row];
        return (row);
    }
  		
	void doSort()
	{
		int i,j,k;
		boolean MoreToSort;
        if (theModel==null)
            return;
		if (indexes==null||(indexes.length<theModel.getRowCount())) 
		{
			indexes=new int[theModel.getRowCount()];
		    for (i=0;i<theModel.getRowCount();i++) 
			    indexes[i]=i;
		}

		MoreToSort=true;
		while(MoreToSort)
		{
			MoreToSort=false;
			for (i=0;i<theModel.getRowCount()-1;i++)
			{
				j=compareObjects(theModel.getValueAt(indexes[i], ColumnToSort), theModel.getValueAt(indexes[i+1], ColumnToSort));
				if ((AscendingSort&&j>0)||((!AscendingSort)&&j<0))
				{
					k=indexes[i];
					indexes[i]=indexes[i+1];
					indexes[i+1]=k;
					MoreToSort=true;
				}
			}
		}
	}

	public int compareObjects(Object A, Object B) 
	{
        // Check for nulls.

		// If both values are null, return 0.
        if (A == null && B == null) 
		{
            return 0; 
        }
		else if (A == null)  // Define null less than everything. 
		{
            return -1; 
        } 
		else if (B == null) 
		{
		    return 1; 
        }

        if (A instanceof java.lang.Number) 
		{
            Number n1 = (Number)A;
            double d1 = n1.doubleValue();
            Number n2 = (Number)B;
            double d2 = n2.doubleValue();

            if (d1 < d2) 
			{
                return -1;
            }
			else if (d1 > d2) 
			{
                return 1;
            }
			else 
			{
                return 0;
            }
        }
		else if (A instanceof java.util.Date) 
		{
            Date d1 = (Date)A;
            long n1 = d1.getTime();
            Date d2 = (Date)B;
            long n2 = d2.getTime();

            if (n1 < n2) 
			{
                return -1;
            }
			else if (n1 > n2) 
			{
                return 1;
            }
			else 
			{
                return 0;
            }
        }
		else if (A instanceof String) 
		{
            String s1 = (String)A;
            String s2    = (String)B;
            int result = s1.compareTo(s2);

            if (result < 0) 
			{
                return -1;
            }
			else if (result > 0) 
			{
                return 1;
            }
			else 
			{
                return 0;
            }
        } 
		else if (A instanceof Boolean) 
		{
            Boolean bool1 = (Boolean)A;
            boolean b1 = bool1.booleanValue();
            Boolean bool2 = (Boolean)B;
            boolean b2 = bool2.booleanValue();

            if (b1 == b2) 
			{
                return 0;
            } 
			else if (b1)  // Define false < true
			{	
                return 1;
            }
			else 
			{
                return -1;
            }
        } 
		else 
		{
            String s1 = A.toString();
            String s2 = B.toString();
            int result = s1.compareTo(s2);

            if (result < 0) 
			{
                return -1;
            }
			else if (result > 0) 
			{
                return 1;
            }
			else 
			{
        		return 0;
            }
        }
    }
	
	public void mouseDragged(MouseEvent e)
	{
	}
	
	public void mouseMoved(MouseEvent e)
	{
   	    int inFocus=convertColumnIndexToModel(getTableHeader().columnAtPoint(e.getPoint()));
   	    if (ColumnInFocus!=inFocus)
   	    {
   	        ColumnInFocus=inFocus;
   	   	    getTableHeader().repaint();
   	   	}
	}


	public void mouseEntered(MouseEvent m)
	{
   	    ColumnInFocus=convertColumnIndexToModel(getTableHeader().columnAtPoint(m.getPoint()));
   	   	getTableHeader().repaint();

    }
	
	public void mouseExited(MouseEvent m)
	{
        ColumnInFocus=-1;
   	   	getTableHeader().repaint();

	}
	
	public void mousePressed(MouseEvent m)
	{
	    ColumnSelected=convertColumnIndexToModel(getTableHeader().columnAtPoint(m.getPoint()));
   	   	getTableHeader().repaint();

    }

	public void mouseReleased(MouseEvent m)
	{
	    ColumnSelected=-1;
    	getTableHeader().repaint();
    }

	public void mouseClicked(MouseEvent m)
	{
		int TargetCol=convertColumnIndexToModel(getTableHeader().columnAtPoint(m.getPoint()));
		if (TargetCol==ColumnToSort)
			AscendingSort=!AscendingSort;
		else
		{
			ColumnToSort=TargetCol;
			AscendingSort=true;
		}
		doSort();
		theModel.tableChanged(new TableModelEvent(theModel));
		getTableHeader().repaint();
	}

	class CustomHeaderRenderer implements TableCellRenderer
	{
		JLabel Renderer;
		ImageIcon Ascending,Descending;
        
		public CustomHeaderRenderer()
		{
			Ascending=new ImageIcon("images/ascending.gif");
			Descending=new ImageIcon("images/descending.gif");
			Renderer=new JLabel();
			Renderer.setHorizontalAlignment(SwingConstants.CENTER);
			Renderer.setHorizontalTextPosition(SwingConstants.RIGHT);
			Renderer.setVerticalTextPosition(SwingConstants.CENTER);
		    Renderer.setForeground(Color.black);
			Renderer.setOpaque(false);
		}
		
		public Component getTableCellRendererComponent(JTable Table,Object Value,boolean Selected,boolean HasFocus,int Row,int Col)
        {
			Renderer.setText(Value.toString());
			int thisCol=Table.convertColumnIndexToModel(Col);
			if (thisCol==ColumnToSort) 
			{
				Renderer.setIcon(AscendingSort ? Ascending : Descending); 
			}
			else 
			{
				Renderer.setIcon(null);
			}
			if (thisCol==ColumnSelected) 
			{
    			Renderer.setBorder(new BevelBorder(BevelBorder.LOWERED));
			}
			else if (thisCol==ColumnInFocus)
			{
    			Renderer.setBorder(new BevelBorder(BevelBorder.RAISED));
			}
			else
			{
    			Renderer.setBorder(new EmptyBorder(2, 2, 2, 2));
			}
			return Renderer;
		}
	}

	//{{DECLARE_CONTROLS
	//}}
}