// package jtalk;

import java.net.*;
import java.io.*;
import java.util.*;

public class negotiator extends Thread
{
	String localUser;
	String localIP=getIPorDNS.getLocalIP();
	
	String remoteUser;
	String remoteIP;
	String remoteTTY="";
	
	comunicate Comunication;
	createServerSocket theConection;
	DatagramSocket theDatagramSocket;
	ctl_msg request;
	ctl_response response;
	JTalkGUI parent;
	boolean DEBUG;
	
	public  negotiator(JTalkGUI parent, boolean DEBUG)
	{
	    this.DEBUG=DEBUG;
		this.remoteIP=parent.remoteIP;
		this.remoteUser=parent.remoteUser;
		this.localUser=parent.localUser;
		this.parent=parent;	
 		
		try 
		{
			this.request=createRequest(constants.LOOK_UP);
			this.theDatagramSocket = new DatagramSocket();
			this.request.ctl_addr.port=(char)theDatagramSocket.getLocalPort();
			this.Comunication=new comunicate(theDatagramSocket, parent.DEBUG);
			
		}
		catch (SocketException se) 
		{
		    if (DEBUG)
			    System.err.println("Couln'd negotiate, Socket Exception "+se);
	    }
	
		//{{INIT_CONTROLS
		//}}
	}

	public void run()
	{
		while (theDatagramSocket!=null) 
		{
	    	response=Comunication.sendWithConfirmation(request, remoteIP);
			if (response==null)
			{
			    if (DEBUG)
				    System.err.println("The server is not responding "+remoteIP);
				parent.Status.setText("The server is not responding :(");
				this.stop();
			}
			if (DEBUG)
			    System.err.println("DIALOG: "+constants.REQUEST[request.type]+" :: "+constants.RESPONSE[response.answer]);
			request.id_num=response.id_num;
			switch (request.type)
			{
				case constants.LOOK_UP:
					if(response.answer == constants.SUCCESS)
					{
						parent.Status.setText("The remote party is already waiting for us. \nConnecting to the given port.");
                        connectToServer conection;
						conection=new connectToServer(request, 0, DEBUG);
                        this.close();
                        if(constants.FORK)
                            System.exit(1);
					}
					else if (response.answer == constants.NOT_HERE)
					{
						parent.Status.setText("The remote party is not waiting for us :(. \nSending invitation to the remote party.");
						theConection=new createServerSocket(this, request, DEBUG);
						theConection.start();
						request.addr.family=constants.AF_INET;
						request.addr.port=(char)theConection.getPort();
						request.addr.ip=getIPorDNS.ipToDotless(localIP);
						request.type=constants.LEAVE_INVITE;
						Comunication.sendWithConfirmation(request, localIP);
						request.type=constants.ANNOUNCE;
					}
					else
					{
						if (response.answer>9 || response.answer<0)
							response.answer=9;
						if (DEBUG)
						    System.err.println("ERROR: Server ("+response.getHost()+") returned " + constants.RESPONSE[response.answer]+".");
						parent.Status.setText("ERROR: Server returned " + constants.RESPONSE[response.answer]+".");
						this.stop();
					}
			break;	
		
		
			case constants.ANNOUNCE:
				if (response.answer== constants.SUCCESS)
				{
					parent.Status.setText("Waiting for the remote party to respond to the invitation.");
					try
					{	
						this.sleep(constants.RING_WAIT * 1000);
					}
					catch (InterruptedException e) 
					{
						if (DEBUG)
						    System.err.println("Interruperted Exception while waiting for response from the remopte party "+e);
					}
					//retry and wait for the connection 
					request.id_num+=1;
					parent.Status.setText("Resending the intitation for the remote party.");
					request.type=constants.ANNOUNCE;
					Comunication.sendWithConfirmation(request, localIP);
					request.type=constants.LEAVE_INVITE;
				}
				else if (response.answer== constants.NOT_HERE)
				{
						parent.Status.setText("User '"+request.getCalleeName()+"' isn't logon on the remote server ("+request.getRemoteDNS()+").");
						this.end();
				}
				else if (response.answer== constants.PERMISSION_DENIED)
				{
						parent.Status.setText("You don't have the permission to talk to '"+request.getCalleeName()+"' on the remote server ("+request.getRemoteDNS()+").");
						this.end();
				}
				else
				{
					if (response.answer>9 || response.answer<0)
						response.answer=9;
					if (DEBUG)
					    System.err.println("ERROR: Server ("+response.getHost()+") returned " + constants.RESPONSE[response.answer]+".");
					parent.Status.setText("ERROR: Server returned " + constants.RESPONSE[response.answer]+".");
					this.stop();
				}
			break;
		
			case constants.LEAVE_INVITE:
				request.type=constants.ANNOUNCE;
			break;

			case constants.DELETE:  
				parent.Status.setText("Delete request type was send, stopping.");
				this.stop();
			break;
		
			default:
				{
					if (response.answer>9 || response.answer<0)
						response.answer=9;
					System.err.println("ERROR: Server ("+response.getHost()+") returned " + constants.RESPONSE[response.answer]+".");
					parent.Status.setText("ERROR: Server returned " + constants.RESPONSE[response.answer]+".");
					this.end();
				}
			break;
		}
	} 
  } 

  void sendDelete()
  {
	 if(request==null || Comunication==null)
		 return;
	 request.type=constants.DELETE;
	 Comunication.sendWithConfirmation(request, localIP);
//	 Comunication.sendWithConfirmation(request, remoteIP);
 }

  void abort()
  {
	  parent.Status.setText("Aborted by user.");
	  if(this.theDatagramSocket!=null)
	  {
		  sendDelete();
	      closeSocket();
      }
  }
	
	
  ctl_msg createRequest(int type)
  {
		ctl_msg request=new ctl_msg();
		request.type=(byte)type;
		request.id_num=1;
		request.addr=new osockaddr();
		request.ctl_addr=new osockaddr(constants.AF_INET, '\0', getIPorDNS.ipToDotless(localIP));
		request.pid=(int)(Math.random()*100000);
		request.l_name=localUser.getBytes();
		request.r_name=remoteUser.getBytes();
		request.r_tty=remoteTTY.getBytes();	
		return request;
	}
	
	void end()
	{
		closeSocket();
        parent.reset();
	}
	
	void closeSocket()
	{
   		if(theDatagramSocket!=null)
		{
			theDatagramSocket.close();
            theDatagramSocket=null;
		}
 
	}

	void close()
	{
		closeSocket();
        parent.close();
	}
	//{{DECLARE_CONTROLS
	//}}
}
