// package jtalk;

import java.util.*;
import java.net.*;
import java.io.*;
import java.text.DateFormat;
import javax.swing.*;

public class request
{

	boolean DEBUG;
	ctl_msg request;
	ctl_response response;
	RequestDialog theRequest;
	DatagramSocket theDatagramSocket;
	DatagramPacket outDatagramPacket;	

    request(ctl_msg request, ctl_response response, boolean DEBUG)
	{
	    this.DEBUG=DEBUG;
		this.request=request;
		this.response=response;
		try 
		{
			theDatagramSocket = new DatagramSocket();
		}
		catch (SocketException se) 
		{
		    if (DEBUG)
			    System.err.println("Couldn't create Datagram Socket to send out response "+se);
		}
		if (jtalkd.talkMode==3 || jtalkd.talkMode==4)  // handle auto-anser machine or auto-fortune
		    returnStatus(jtalkd.talkMode);
		else
		{   
            int action=-1;
            action=addressBook.getAction(request.getCallerName(), request.getRemoteDNS(), DEBUG);
            if (action<0 || action>=constants.ACTION_CHOICES.length)
            {
                theRequest=new RequestDialog(this);
                theRequest.setVisible(true);
            }
            else
            {
                returnStatus(action);
            }
        }
	}
	
	public void returnStatus(int selected)
	{
	    if (theRequest!=null)
		    theRequest.dispose();
		switch (selected)
        {
            case 0:  //normal
                response.answer=constants.SUCCESS;
		        sendResponse();
                createConnection(constants.TALK_MODE_NORMAL);
                break;
            case 1: //not here
                response.answer=constants.NOT_HERE;
		        sendResponse();
		        break;
            case 2: // permission denied
                response.answer=constants.PERMISSION_DENIED;
		        sendResponse();
		        break;
            case 3: // answer machine
                response.answer=constants.SUCCESS;
		        sendResponse();
                createConnection(constants.TALK_MODE_ANSWER_MACHINE);  
                break;
            case 4: // fortune
                response.answer=constants.SUCCESS;
		        sendResponse();
                createConnection(constants.TALK_MODE_FORTUNE);
                break;
            case 5: //ignore
                break;
            default:
                break;
        }
	}
	
	void createConnection(int mode)
	{
	    if (!constants.FORK)
	    {
            new connectToServer(request, mode, DEBUG);
        }
        else
        {
            String[] theProgram=new String[13];
            int i=0;
            theProgram[i++]="java chat";
            theProgram[i++]=new Integer(request.type).toString();
            theProgram[i++]=new Integer(request.id_num).toString();
            theProgram[i++]=new Integer(request.addr.family).toString();
            theProgram[i++]=new Integer(request.addr.port).toString();
            theProgram[i++]=new Long(request.addr.ip).toString();
            theProgram[i++]=new Integer(request.ctl_addr.family).toString();
            theProgram[i++]=new Integer(request.ctl_addr.port).toString();
            theProgram[i++]=new Long(request.ctl_addr.ip).toString();
            theProgram[i++]=new Integer(request.pid).toString();
            theProgram[i++]=request.getCallerName();
            theProgram[i++]=request.getCalleeName();
            theProgram[i++]=new Integer(mode).toString();

            Runtime rn=Runtime.getRuntime();
            try
            {
                rn.exec(theProgram);
            }
            catch(IOException exception)
            {
                if (DEBUG)
                    System.err.println("Couldn't start TalkGUI. "+exception);
                return;
            }
      }  
	}
	
	void sendResponse()
	{
		try
		{
			outDatagramPacket=new DatagramPacket(response.toBytes(), response.toBytes().length,  InetAddress.getByName(request.getRemoteDNS()), request.getCalleePortUDP());
			theDatagramSocket.send(outDatagramPacket);
			if (DEBUG)
            {
			    System.err.println("Send respond at: "+ DateFormat.getDateTimeInstance().format(new Date()));
				System.err.println(response.toString());
            }
		}
		catch (UnknownHostException uhe) 
		{
			if(DEBUG)
			    System.err.println("Couldn't create Datagram Packet to unknown host "+uhe);
		}
		catch (IOException e) 
		{
			if(DEBUG)
			    System.err.println("Couldn't create Datagram Packet got intereped "+e);
		}   					
	}
}